<?php

namespace Inouit\InGalleryFlickr\Controller;

/**
 * The album controller for the in_gallery_flickr extension
 *
 * @package in_gallery_flickr
 *
 */
class AlbumController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {

	/**
	 * @var \Inouit\InGalleryFlickr\Domain\Repository\AlbumRepository
	 * @inject
	 */
	protected $albumRepository;
	
	/**
	 * Initializes the current action.
	 *
	 * @return void
	 */
	public function initializeAction() {
		$this->albumRepository = $this->objectManager->get('Inouit\InGalleryFlickr\Domain\Repository\AlbumRepository');
	}
	
	/**
	 * Initialize view
	 *
	 * @return void
	 */ 
	public function initializeView(\TYPO3\CMS\Extbase\Mvc\View\ViewInterface $view) {
		$pageRenderer = $GLOBALS['TSFE']->getPageRenderer();
		if($this->settings['includeJQuery']) {
			$pageRenderer->addJsLibrary( 'jquery', '/typo3conf/ext/in_gallery_flickr/Resources/Public/Media/js/jquery-1.7.2.min.js' );
		}
		if($this->settings['includeFancyBox']) {
			$pageRenderer->addJsFooterLibrary( 'jquery.fancybox', '/typo3conf/ext/in_gallery_flickr/Resources/Public/Media/js/fancybox/jquery.fancybox-1.3.4.js' );
			$pageRenderer->addJsFooterLibrary( 'jquery.mousewheel', '/typo3conf/ext/in_gallery_flickr/Resources/Public/Media/js/fancybox/jquery.mousewheel-3.0.4.pack.js' );
			$pageRenderer->addJsFooterLibrary( 'jquery.easing', '/typo3conf/ext/in_gallery_flickr/Resources/Public/Media/js/fancybox/jquery.easing-1.3.pack.js' );

			$pageRenderer->addCssFile('/typo3conf/ext/in_gallery_flickr/Resources/Public/Media/js/fancybox/jquery.fancybox-1.3.4.css');
		}
		if($this->settings['includeGalleryCSS']) {
			$pageRenderer->addCssFile	('/typo3conf/ext/in_gallery_flickr/Resources/Public/Media/styles/inouit.gallery.albumList.css');
		}

		if($this->settings['album']['itemPerPage'] !== null && $this->settings['album']['itemPerPage'] > 0) {
			$pageRenderer->addCssFile('/typo3conf/ext/in_gallery_flickr/Resources/Public/Media/js/jquery.paginate/jquery.paginate.css');
			$pageRenderer->addJsFooterLibrary( 'jquery.paginate', '/typo3conf/ext/in_gallery_flickr/Resources/Public/Media/js/jquery.paginate/jquery.paginate.js' );
			$pageRenderer->addJsFooterInlineCode( 'jquery.paginateInit', '
				(function($){
					$(document).ready(function(){
						$(".albumList").paginate({ children: ".album", itemPerPage: "'.$this->settings['album']['itemPerPage'].'" });
					});
				})(jQuery);
			' );

			
		}

    	parent::initializeAction();
	}

	/**
	 * list action.
	 *
	 * @return void
	 */
	public function listAction() {
		$albums = $this->albumRepository->findAll();
        $this->view->assign('albums', $albums);
	}
}

?>