<?php

namespace Inouit\InGalleryFlickr\Domain\Model;

/**
 * A album
 *
 * @package in_gallery_flickr
 *
 */

class Album extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
	const SIZE_SMALL_SQUARE 	= 's';
	const SIZE_LARGE_SQUARE 	= 'q';
	const SIZE_THUMBNAIL    	= 't';
	const SIZE_SMALL_240    	= 'm';
	const SIZE_SMALL_320    	= 'n';
	const SIZE_MEDIUM_640    	= 'z';
	const SIZE_MEDIUM_800    	= 'c';
	const SIZE_BIG_1024       	= 'b';
	const SIZE_ORIGIN       	= 'o';


	/**
	 * The Album's albumId
	 *
	 * @var string
	 */
	protected $albumId = '';

	/**
	 * The Album's title
	 *
	 * @var string
	 */
	protected $title = '';

	/**
	 * A short description description
	 *
	 * @var string
	 */
	protected $description = '';

	/**
	 * The Album's url
	 *
	 * @var string
	 */
	protected $url = '';

	/**
	 * The Album's cover
	 *
	 * @var string
	 */
	protected $cover = '';

	/**
	 * The Album's secret
	 *
	 * @var string
	 */
	protected $secret = '';

	/**
	 * The Album's server
	 *
	 * @var string
	 */
	protected $server = '';

	/**
	 * The Album's farm
	 *
	 * @var string
	 */
	protected $farm = '';

	/**
	 * Album's tstamp
	 * @var \integer
	 */
	protected $tstamp;

	/**
	 * Constructs a new Album
	 *
	 */
	public function __construct()
	{
		$this->posts = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}

	/**
	 * Sets this album's albumId
	 *
	 * @param string $albumId The album's albumId
	 * @return void
	 */
	public function setAlbumId($albumId)
	{
		$this->albumId = $albumId;
	}

	/**
	 * Returns the album's albumId
	 *
	 * @return string The album's albumId
	 */
	public function getAlbumId()
	{
		return $this->albumId;
	}

	/**
	 * Sets this album's title
	 *
	 * @param string $title The album's title
	 * @return void
	 */
	public function setTitle($title)
	{
		$this->title = $title;
	}

	/**
	 * Returns the album's title
	 *
	 * @return string The album's title
	 */
	public function getTitle()
	{
		return $this->title;
	}

	/**
	 * Sets the description for the album
	 *
	 * @param string $description
	 * @return void
	 */
	public function setDescription($description)
	{
		$this->description = $description;
	}

	/**
	 * Returns the description
	 *
	 * @return string
	 */
	public function getDescription()
	{
		return $this->description;
	}

	/**
	 * Sets this album's url
	 *
	 * @param string $url The album's url
	 * @return void
	 */
	public function setUrl($url)
	{
		$this->url = $url;
	}

	/**
	 * Returns the album's url
	 *
	 * @return string The album's url
	 */
	public function getUrl()
	{
		return $this->url;
	}

	/**
	 * Sets this album's cover
	 *
	 * @param string $cover The album's cover
	 * @return void
	 */
	public function setCover($cover)
	{
		$this->cover = $cover;
	}

	/**
	 * Returns the album's cover
	 *
	 * @return string The album's cover
	 */
	public function getCover()
	{
		return $this->cover;
	}

	/**
	 * Sets this album's secret
	 *
	 * @param string $secret The album's secret
	 * @return void
	 */
	public function setSecret($secret)
	{
		$this->secret = $secret;
	}

	/**
	 * Returns the album's secret
	 *
	 * @return string The album's secret
	 */
	public function getSecret()
	{
		return $this->secret;
	}

	/**
	 * Sets this album's server
	 *
	 * @param string $server The album's server
	 * @return void
	 */
	public function setServer($server)
	{
		$this->server = $server;
	}

	/**
	 * Returns the album's server
	 *
	 * @return string The album's server
	 */
	public function getServer()
	{
		return $this->server;
	}

	/**
	 * Sets this album's farm
	 *
	 * @param string $farm The album's farm
	 * @return void
	 */
	public function setFarm($farm)
	{
		$this->farm = $farm;
	}

	/**
	 * Returns the album's farm
	 *
	 * @return string The album's farm
	 */
	public function getFarm()
	{
		return $this->farm;
	}

	/**
	 * Getter for tstamp
	 *
	 * @return string
	 */
	public function getTstamp() {
	    return $this->tstamp;
	}


	/**
	 * Setter for tstamp
	 *
	 * @param  string  tstamp
	 * @return string
	 */
	public function setTstamp($tstamp) {
	    $this->tstamp = $tstamp;
	    return $this;
	}


	/**
	 * Returns the album's urlCoverPhoto
	 *
	 * @return string The album's urlCoverPhoto
	 */
	public function getPhotoUrl($sizePhoto = Album::SIZE_THUMBNAIL)
	{
		return 'http://farm'.$this->getFarm().'.staticflickr.com/'.$this->getServer().'/'.$this->getCover().'_'.$this->getSecret().'_'.$sizePhoto.'.jpg';
	}

}
?>