<?php

namespace Inouit\InGalleryFlickr\Domain\Model;

/**
 * A album
 *
 * @package in_gallery_flickr
 *
 */

class Photo extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * The Photo's id
	 *
	 * @var string
	 */
	protected $id = '';

	/**
	 * The Photo's id
	 *
	 * @var string
	 */
	protected $albumId = '';

	/**
	 * The Photo's secret
	 *
	 * @var string
	 */
	protected $secret = '';

	/**
	 * The Photo's secret
	 *
	 * @var string
	 */
	protected $originalsecret = '';

	/**
	 * The Photo's server
	 *
	 * @var string
	 */
	protected $server = '';

	/**
	 * The Photo's farm
	 *
	 * @var string
	 */
	protected $farm = '';

	/**
	 * The Photo's title
	 *
	 * @var string
	 */
	protected $title = '';

	/**
	 * The Photo's isPrimary
	 *
	 * @var string
	 */
	protected $isPrimary = '';

	/**
	 * getter for id
	 * 
	 * @return string
	 */
	public function getId() {
	    return $this->id;
	}
		
	/**
	 * setter for id
	 * 
	 * @param string $id
	 */
	public function setId($id) {
	    $this->id = $id;
	}

	/**
	 * getter for albumId
	 * 
	 * @return string
	 */
	public function getAlbumId() {
	    return $this->albumId;
	}
		
	/**
	 * setter for albumId
	 * 
	 * @param string $albumId
	 */
	public function setAlbumId($albumId) {
	    $this->albumId = $albumId;
	}
	

	/**
	 * getter for secret
	 * 
	 * @return string
	 */
	public function getSecret() {
	    return $this->secret;
	}
		
	/**
	 * setter for secret
	 * 
	 * @param string $secret
	 */
	public function setSecret($secret) {
	    $this->secret = $secret;
	}

	/**
	 * getter for originalsecret
	 * 
	 * @return string
	 */
	public function getOriginalsecret() {
	    return $this->originalsecret;
	}
		
	/**
	 * setter for originalsecret
	 * 
	 * @param string $originalsecret
	 */
	public function setOriginalsecret($originalsecret) {
	    $this->originalsecret = $originalsecret;
	}
	
	
	/**
	 * getter for server
	 * 
	 * @return string
	 */
	public function getServer() {
	    return $this->server;
	}
		
	/**
	 * setter for server
	 * 
	 * @param string $server
	 */
	public function setServer($server) {
	    $this->server = $server;
	}
	
	/**
	 * getter for farm
	 * 
	 * @return string
	 */
	public function getFarm() {
	    return $this->farm;
	}
		
	/**
	 * setter for farm
	 * 
	 * @param string $farm
	 */
	public function setFarm($farm) {
	    $this->farm = $farm;
	}
	
	/**
	 * getter for title
	 * 
	 * @return string
	 */
	public function getTitle() {
	    return $this->title;
	}
		
	/**
	 * setter for title
	 * 
	 * @param string $title
	 */
	public function setTitle($title) {
	    $this->title = $title;
	}

	/**
	 * getter for isPrimary
	 * 
	 * @return string
	 */
	public function getIsPrimary() {
	    return $this->isPrimary;
	}
		
	/**
	 * setter for isPrimary
	 * 
	 * @param string $isPrimary
	 */
	public function setIsPrimary($isPrimary) {
	    $this->isPrimary = $isPrimary;
	}


	/**
	 * Populate the object
	 * 	
	 * @param  array  $datas
	 * @return void
	 */
	public function __populate(array $datas = array()) {
		if(count($datas)){
			foreach($datas as $key=>$value){
				$this->_setProperty($key, $value);
			}
		}

		$this->__wakeup();
	}

	/**
	 * Returns the photo
	 *
	 * @return string The Photo
	 */
	public function getPhotoUrl($sizePhoto = Album::SIZE_BIG_1024) {
		return 'http://farm'.$this->getFarm().'.staticflickr.com/'.$this->getServer().'/'.$this->getId().'_'. ( $sizePhoto == Album::SIZE_ORIGIN ? $this->getOriginalsecret() : $this->getSecret() ).'_'.$sizePhoto.'.jpg';
	}
}