<?php

namespace Inouit\InGalleryFlickr\Domain\Repository;

/**
 * A repository for album
 *
 * @package in_gallery_flickr
 *
 */
class AlbumRepository extends \TYPO3\CMS\Extbase\Persistence\Repository {
	protected $defaultOrderings = array( 'sorting' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING );

  /**
   * @var \TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface
   * @inject
   */
  protected $configurationManager;

	/**
	 * Find the last Album
	 * @return ArrayCollection the last album
	 */
	public function findOneFirst()	{
		$query = $this->createQuery()
			->setLimit(1);

		return $query->execute();
	}

	/**
	 * Find the last Album
	 * @return ArrayCollection the last album
	 */
	public function findAllForSitemap()	{
		$query = $this->createQuery();
    $query->getQuerySettings()->setRespectStoragePage(FALSE);
		return $this->convertToUrls($query->execute());
	}

  /**
   * Convert results to array of Urls objects
   * @param  array $results results of a query
   * @return array list of Urls
   */
  private function convertToUrls(array $results) {
    $convertedResults = array();
    if(count($results)) {
	    $settings       = $GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_ingalleryflickr.']['settings.'];
      $uriBuilder = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance( 'TYPO3\CMS\Extbase\Mvc\Web\Routing\UriBuilder' );
      $cObj = $this->configurationManager->getContentObject();
      $uris = array();
      foreach($results as $result) {
        $url = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance( 'Inouit\InSitemap\Domain\Model\Url' );
        $uri = $cObj->typoLink_URL(array(
          'parameter' => $settings['singleView'],
          'forceAbsoluteUrl' => 1,
          'additionalParams' => '&tx_ingalleryflickr_pi1[album]='.$result->getUid().'&tx_ingalleryflickr_pi1[action]=show&tx_ingalleryflickr_pi1[controller]=Viewer'

        ));
        if($uri && !in_array($uri, $uris)) {
          $url->__populate(array(
            'loc' => $uri,
            'tstamp' => $result->getTstamp()
          ));
          array_push($convertedResults, $url);
          array_push($uris, $uri);
        }
      }
    }
    return $convertedResults;
  }
}
?>