<?php

namespace Inouit\InGalleryFlickr\Hooks;

/***************************************************************
*  Copyright notice
*
*  (c) 2011 by www.inouit.com
*  (p) 2011 by Yann Prou <yprou@inouit.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Frontend plugin 'In FlickrImages'
 *
 * @author	Yann Prou <yprou@inouit.com>
 */

// require_once(PATH_t3lib. 'class.t3lib_befunc.php');

class Tcemainprocdm
{
	private $_EXTKEY = 'in_gallery_flickr';
	private $flickrPhotosetsId;

	private function getAlbumInfos($photoset) {
		return array(
			'album_id' 			=> $photoset['id'],
			'title' 		=> $photoset['title']['_content'],
			'description' => $photoset['description']['_content'],
			'cover' 	=> $photoset['primary'],
			'secret' 		=> $photoset['secret'],
			'server' 		=> $photoset['server'],
			'farm' 		=> $photoset['farm'],
			'url'				=> ($photoset['owner'] ? 'https://www.flickr.com/photos/'.$photoset['owner'].'/sets/'.$photoset['id'].'/' : '')
			);
	}

	public function processDatamap_preProcessFieldArray(&$incomingFieldArray, $table, $id, $pObj) {
		global $TSFE;

		if ($table == 'tx_ingalleryflickr_domain_model_album' && $id!==null){
			if($incomingFieldArray['album_id'] !== null ) {
				$this->flickrPhotosetsId = $incomingFieldArray['album_id'];

				// Init Connexion Flickr
				$flickrObj = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('Inouit\InGalleryFlickr\Service\FlickrService');
				$flickrObj->setApiKey($this->_EXTKEY);
				$flickrObj->setDisplayErrors(true);
				// $flickrObj = t3lib_div::makeInstance('Tx_InGalleryFlickr_Domain_Flickr', $this->getFlickrApiKey(), array());

				$results = $flickrObj->prepareAndSendRequest(array(
						'method' 		=> 'flickr.photosets.getInfo',
						'photoset_id'	=> $this->flickrPhotosetsId
					));

				$incomingFieldArray = array_merge($incomingFieldArray, $this->getAlbumInfos($results['photoset']));
			}
		}
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/in_gallery_flickr/Hooks/class.tx_ingalleryflickr_tcemainprocdm.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/in_gallery_flickr/Hooks/class.tx_ingalleryflickr_tcemainprocdm.php']);
}

?>