<?php
if (!defined ('TYPO3_MODE')) {
	die ('Access denied.');
}

$TCA['tx_ingalleryflickr_domain_model_album'] = array (
	'ctrl' => $TCA['tx_ingalleryflickr_domain_model_album']['ctrl'],
	'interface' => array (
		'showRecordFieldList' => 'hidden, starttime, endtime, album_id, title, description, url, cover, secret, server, farm'
	),
	'feInterface' => $TCA['tx_ingalleryflickr_domain_model_album']['feInterface'],
	'columns' => array (
		'sys_language_uid' => Array (
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.language',
			'config' => Array (
				'type' => 'select',
				'foreign_table' => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => Array(
					Array('LLL:EXT:lang/locallang_general.php:LGL.allLanguages',-1),
					Array('LLL:EXT:lang/locallang_general.php:LGL.default_value',0)
				)
			)
		),
		'l18n_parent' => Array (
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.l18n_parent',
			'config' => Array (
				'type' => 'select',
				'items' => Array (
					Array('', 0),
				),
				'foreign_table' => 'tx_ingalleryflickr_domain_model_album',
				'foreign_table_where' => 'AND tx_ingalleryflickr_domain_model_album.uid=###REC_FIELD_l18n_parent### AND tx_ingalleryflickr_domain_model_album.sys_language_uid IN (-1,0)',
			)
		),
		'l18n_diffsource' => Array(
			'config'=>array(
				'type'=>'passthrough'
			)
		),
		'hidden' => array (
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.hidden',
			'config'  => array (
				'type'    => 'check',
				'default' => '0'
			)
		),
		'starttime' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.starttime',
			'config'  => array (
				'type'     => 'input',
				'size'     => '8',
				'max'      => '20',
				'eval'     => 'date',
				'default'  => '0',
				'checkbox' => '0'
			)
		),
		'endtime' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.endtime',
			'config'  => array (
				'type'     => 'input',
				'size'     => '8',
				'max'      => '20',
				'eval'     => 'date',
				'checkbox' => '0',
				'default'  => '0',
				'range'    => array (
					'upper' => mktime(3, 14, 7, 1, 19, 2038),
					'lower' => mktime(0, 0, 0, date('m')-1, date('d'), date('Y'))
				)
			)
		),
		'album_id' => array (
			'exclude' => 0,
			'label' => 'LLL:EXT:in_gallery_flickr/Resources/Private/Language/locallang_db.xml:tx_ingalleryflickr_domain_model_album.albumId',
			'config' => array (
				'type' => 'input',
				'size' => 30,
				'eval' => 'trim,required',
				'max' => 255
			)
		),
		'title' => array (
			'exclude' => 0,
			'label' => 'LLL:EXT:in_gallery_flickr/Resources/Private/Language/locallang_db.xml:tx_ingalleryflickr_domain_model_album.title',
			'config' => array (
				'type' => 'input',
				'size' => 30,
				'readOnly' => 1
			)
		),
		'description' => array (
				'exclude' => 0,
				'label' => 'LLL:EXT:in_gallery_flickr/Resources/Private/Language/locallang_db.xml:tx_ingalleryflickr_domain_model_album.description',
				'config' => Array (
					'type' => 'text',
					'cols' => 48,
					'rows' => 5,
					'readOnly' => 1
				)
		),
		'url' => array (
			'exclude' => 0,
			'label' => 'LLL:EXT:in_gallery_flickr/Resources/Private/Language/locallang_db.xml:tx_ingalleryflickr_domain_model_album.url',
			'config' => array (
				'type' => 'input',
				'size' => 30,
				'readOnly' => 1
			)
		),
		'cover' => array (
			'exclude' => 0,
			'label' => 'LLL:EXT:in_gallery_flickr/Resources/Private/Language/locallang_db.xml:tx_ingalleryflickr_domain_model_album.cover',
			'config' => array (
				'type' => 'input',
				'size' => 30,
				'readOnly' => 1
			)
		),
		'secret' => array (
			'exclude' => 0,
			'label' => 'LLL:EXT:in_gallery_flickr/Resources/Private/Language/locallang_db.xml:tx_ingalleryflickr_domain_model_album.secret',
			'config' => array (
				'type' => 'input',
				'size' => 30,
				'readOnly' => 1
			)
		),
		'server' => array (
			'exclude' => 0,
			'label' => 'LLL:EXT:in_gallery_flickr/Resources/Private/Language/locallang_db.xml:tx_ingalleryflickr_domain_model_album.server',
			'config' => array (
				'type' => 'input',
				'size' => 30,
				'readOnly' => 1
			)
		),
		'farm' => array (
			'exclude' => 0,
			'label' => 'LLL:EXT:in_gallery_flickr/Resources/Private/Language/locallang_db.xml:tx_ingalleryflickr_domain_model_album.farm',
			'config' => array (
				'type' => 'input',
				'size' => 30,
				'readOnly' => 1
			)
		),
	),
	'types' => array (
		'1' => array( 'showitem' => 'album_id;;access,title,description,url,cover,secret,server,farm,--div--;LLL:EXT:cms/locallang_ttc.xlf:tabs.access,starttime, endtime' ),
	),
	'palettes' => array (
		'access' => array('showitem' => 'hidden'),
	)
);
?>